From: Carlos Maddela <e7appew@gmail.com>
Date: Fri, 6 Jul 2018 09:30:47 +1000
Subject: Don't suggest to save PS file over original PDF file.

Description: Don't suggest to save PS file over original PDF file.
 Also retitle 'Save File as' and 'Export PDF' dialogs more appropriately.
Author: Carlos Maddela <e7appew@gmail.com>
Bug-Debian: https://bugs.debian.org/903091
Last-Update: 2018-07-06
---
This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
---
 src/flpsed.cxx | 33 +++++++++++++++++++++++++--------
 1 file changed, 25 insertions(+), 8 deletions(-)

diff --git a/src/flpsed.cxx b/src/flpsed.cxx
index 0ca8265..353fcf9 100644
--- a/src/flpsed.cxx
+++ b/src/flpsed.cxx
@@ -142,17 +142,21 @@ bool is_pdf(const char *file) {
 	return (strncmp(buf, "%PDF", sizeof(buf)) == 0);
 }
 
+char *new_title(const char *file) {
+	static const char *title_prefix = "flpsed - ";
+	int title_len = strlen(file) + strlen(title_prefix) + 1;
+	char *title = (char*) malloc(title_len);
+
+	snprintf(title, title_len, "%s%s", title_prefix, file);
+	return title;
+}
 
 void open_file(char *file) {
 	FILE *p;
 	int status;
 	const char *args[5];
 	pid_t pid;
-	static const char *title_prefix = "flpsed - ";
-	int title_len = strlen(file) + strlen(title_prefix) + 1;
-	char *title = (char*) malloc(title_len);
-
-	snprintf(title, title_len, "%s%s", title_prefix, file);
+	char *title = new_title(file);
 
 	if (is_pdf(file)) {
 		// assume pdf and try to import it using pdftops
@@ -213,7 +217,7 @@ void export_pdf_cb() {
 	const char *args[5];
 	pid_t pid;
 
-	file = fl_file_chooser("Open File?", "*.pdf", NULL);
+	file = fl_file_chooser("Export PDF?", "*.pdf", NULL);
 	if(file != NULL && confirm_overwrite(file)) {
 		args[0] = "ps2pdf";
 		args[1] = "-";
@@ -302,9 +306,22 @@ void quit_cb() {
 }
 
 void save_cb() {
-	char *file = fl_file_chooser("Open File?", "*.ps", filename);
-	if (file && confirm_overwrite(file))
+	char *suggested_filename = strdup(filename);
+	char *dot = strrchr(suggested_filename, '.');
+	if (dot && strcasecmp(dot + 1, "pdf") == 0)
+		strcpy(dot + 1, "ps");
+	char *file = fl_file_chooser("Save File as?", "*.ps", suggested_filename);
+	if (file && confirm_overwrite(file)) {
 		psed_p->save(file);
+		if (strcmp(file, filename) != 0) {
+			char *title = new_title(file);
+			win->copy_label(title);
+			free(title);
+			free(filename);
+			filename = strdup(file);
+		}
+	}
+	free(suggested_filename);
 }
 
 void print_cb() {
